__gnu_pbds::trie_string_access_traits< String, Min_E_Val, Max_E_Val, Reverse, _Alloc > Struct Template Reference

## Public Types

enum | { reverse }
enum | { min_e_val, max_e_val, max_size }
typedef _Alloc::template rebind< key_type > | __rebind_k
typedef detail::__conditional_type< Reverse, typename String::const_reverse_iterator, typename String::const_iterator >::__type | const_iterator
typedef std::iterator_traits< const_iterator >::value_type | e_type
typedef __rebind_k::other::const_reference | key_const_reference
typedef String | key_type
typedef _Alloc::size_type | size_type

## Static Public Member Functions

static const_iterator | begin (key_const_reference)
static size_type | e_pos (e_type e)
static const_iterator | end (key_const_reference)

## Detailed Description

### template<typename String = std::string, typename String::value_type Min_E_Val = detail::__numeric_traits<typename String::value_type>::__min, typename String::value_type Max_E_Val = detail::__numeric_traits<typename String::value_type>::__max, bool Reverse = false, typename _Alloc = std::allocator<char>>
struct __gnu_pbds::trie_string_access_traits< String, Min_E_Val, Max_E_Val, Reverse, _Alloc >

Element access traits for string types.

Template Parameters

  String | String type.
  Min_E_Val | Minimal element value.
  Max_E_Val | Maximum element value.
  Reverse | Reverse iteration should be used. Default: false.
  _Alloc | Allocator type.

Definition at line 74 of file trie_policy.hpp.

## Member Typedef Documentation

## const_iterator

template<typename String = std::string, typename String::value_type Min_E_Val = detail::__numeric_traits<typename String::value_type>::__min, typename String::value_type Max_E_Val = detail::__numeric_traits<typename String::value_type>::__max, bool Reverse = false, typename _Alloc = std::allocator<char>>

typedef detail::__conditional_type<Reverse, typename String::const_reverse_iterator, typename String::const_iterator>::__type __gnu_pbds::trie_string_access_traits< String, Min_E_Val, Max_E_Val, Reverse, _Alloc >::const_iterator

Element const iterator type.

Definition at line 90 of file trie_policy.hpp.

## e_type

template<typename String = std::string, typename String::value_type Min_E_Val = detail::__numeric_traits<typename String::value_type>::__min, typename String::value_type Max_E_Val = detail::__numeric_traits<typename String::value_type>::__max, bool Reverse = false, typename _Alloc = std::allocator<char>>

typedef std::iterator_traits<const_iterator>::value_type __gnu_pbds::trie_string_access_traits< String, Min_E_Val, Max_E_Val, Reverse, _Alloc >::e_type

Element type.

Definition at line 93 of file trie_policy.hpp.

## Member Function Documentation

## begin()

template<typename String , typename String::value_type Min_E_Val, typename String::value_type Max_E_Val, bool Reverse, typename _Alloc >

trie_string_access_traits< String, Min_E_Val, Max_E_Val, Reverse, _Alloc >::const_iterator __gnu_pbds::trie_string_access_traits< String, Min_E_Val, Max_E_Val, Reverse, _Alloc >::begin | ( | key_const_reference | r_key | ) |

inline static

Returns a const_iterator to the first element of key_const_reference agumnet.

Definition at line 57 of file trie_policy.hpp.

## e_pos()

template<typename String , typename String::value_type Min_E_Val, typename String::value_type Max_E_Val, bool Reverse, typename _Alloc >

trie_string_access_traits< String, Min_E_Val, Max_E_Val, Reverse, _Alloc >::size_type __gnu_pbds::trie_string_access_traits< String, Min_E_Val, Max_E_Val, Reverse, _Alloc >::e_pos | ( | e_type | e | ) |

inline static

Maps an element to a position.

Definition at line 49 of file trie_policy.hpp.

## end()

template<typename String , typename String::value_type Min_E_Val, typename String::value_type Max_E_Val, bool Reverse, typename _Alloc >

trie_string_access_traits< String, Min_E_Val, Max_E_Val, Reverse, _Alloc >::const_iterator __gnu_pbds::trie_string_access_traits< String, Min_E_Val, Max_E_Val, Reverse, _Alloc >::end | ( | key_const_reference | r_key | ) |

inline static

Returns a const_iterator to the after-last element of key_const_reference argument.

Definition at line 65 of file trie_policy.hpp.

The documentation for this struct was generated from the following file:

- trie_policy.hpp